#include "debug.h"

int core_dump(Word *memory, uint32_t memory_size) {
  FILE *file = fopen("memory_dump.bin", "wb");
  if (!file) {
    perror("Failed to open file");
    return EXIT_FAILURE;
  }
  size_t written = fwrite(memory, 1, memory_size, file);
  if (written != memory_size) {
    fprintf(stderr, "Incomplete write: %zu bytes written out of %u\n", written,
            memory_size);
    fclose(file);
    return EXIT_FAILURE;
  }

  fclose(file);
  return EXIT_SUCCESS;
}
